{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module OGDF.NodeElement.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import OGDF.NodeElement.RawType
import OGDF.NodeElement.FFI
import OGDF.NodeElement.Interface
import OGDF.NodeElement.Cast
import OGDF.NodeElement.RawType
import OGDF.NodeElement.Cast
import OGDF.NodeElement.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => INodeElement (NodeElement) where

instance () => IDeletable (NodeElement) where
        delete = xform0 c_nodeelement_delete

nodeElement_index :: () => NodeElement -> IO CInt
nodeElement_index = xform0 c_nodeelement_nodeelement_index

nodeElement_indeg :: () => NodeElement -> IO CInt
nodeElement_indeg = xform0 c_nodeelement_nodeelement_indeg

nodeElement_outdeg :: () => NodeElement -> IO CInt
nodeElement_outdeg = xform0 c_nodeelement_nodeelement_outdeg

nodeElement_degree :: () => NodeElement -> IO CInt
nodeElement_degree = xform0 c_nodeelement_nodeelement_degree

nodeElement_succ :: () => NodeElement -> IO NodeElement
nodeElement_succ = xform0 c_nodeelement_nodeelement_succ

nodeElement_pred :: () => NodeElement -> IO NodeElement
nodeElement_pred = xform0 c_nodeelement_nodeelement_pred
